sqrt = math.sqrt

-- -- Code from:
-- -- @robga https://github.com/pdstuff/PlaydateSDF
function sdHorseshoe(px, py, cx, cy, r, le, th ) -- c:aperture, r:radius, le:length, th:thickness
    px = ((px >= 0) and px or -px)
    py = -py
    local l = sqrt(px * px + py * py)
    local tx = -cx * px + cy * py
    py = cy * px + cx * py
    px = tx
    if not (py > 0.0 or px > 0.0) then
        px = l * ((-cx > 0.0) and 1.0 or -1.0)
    end
    if px <= 0.0 then
        py = l
    end
    px = px - le
    local pr = py - r
    py = ((pr >= 0) and pr or -pr) - th
    local mx = ((px > 0) and px or 0)
    local my = ((py > 0) and py or 0)
    local lr = sqrt(mx * mx + my * my)
    local m0 = ((px > py) and px or py)
    local mr = ((0 < m0) and 0 or m0)
    return lr + mr 
end
